import { Inject, Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { CONFIG } from '../constants';
var ApiService = (function () {
    function ApiService(http, config) {
        this.http = http;
        var root = config.api_root;
        this.setBaseUrl(root);
        this.setApiRoot(root);
    }
    ApiService.prototype.setBaseUrl = function (url) {
        this.baseUrl = url;
    };
    ApiService.prototype.getBaseUrl = function () {
        return this.baseUrl;
    };
    ApiService.prototype.setApiRoot = function (url) {
        this.apiRoot = url;
    };
    ApiService.prototype.getaApiRoot = function () {
        return this.apiRoot;
    };
    ApiService.prototype.getUrl = function (uri) {
        return this.baseUrl + '/' + uri;
    };
    ApiService.prototype.get = function (uri, options) {
        if (options === void 0) { options = {}; }
        if (options != {}) {
            return this.http.get(this.getUrl(uri), options);
        }
        return this.http.get(this.getUrl(uri));
    };
    ApiService.prototype.post = function (uri, payload) {
        return this.http.post(this.getUrl(uri), payload);
        // return this.makeRequest(uri, 'POST', body, options);
    };
    ApiService.prototype.put = function (uri, payload) {
        return this.http.put(this.getUrl(uri), payload);
        // return this.makeRequest(uri, 'PUT', body, options);
    };
    ApiService.prototype.delete = function (uri, options) {
        if (options === void 0) { options = {}; }
        return this.http.delete(this.getUrl(uri));
        // return this.makeRequest(uri, 'DELETE', null, options);
    };
    ApiService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    ApiService.ctorParameters = function () { return [
        { type: HttpClient, },
        { type: undefined, decorators: [{ type: Inject, args: [CONFIG,] },] },
    ]; };
    return ApiService;
}());
export { ApiService };
//# sourceMappingURL=api.service.js.map