import { Injectable } from '@angular/core';
import { HttpParams } from "@angular/common/http";
import { ApiService } from './api.service';
import { ModelFactory } from '../models/model.factory';
import { Models } from "../models";
import 'rxjs/add/operator/map';
var BackendService = (function () {
    function BackendService(api) {
        this.api = api;
    }
    // set model
    // set model
    BackendService.prototype.setModel = 
    // set model
    function (model) {
        this.model = model;
    };
    BackendService.prototype.find = function (id) {
        var _this = this;
        return this.api.get(new this.model().getUri() + '/' + id).map(function (client) {
            client.data = ModelFactory.make(Models.get(_this.model.key), client.data);
            return client;
        });
    };
    BackendService.prototype.save = function (data) {
        if (data[data.getKey()]) {
            return this.update(data);
        }
        return this.createNew(data);
    };
    BackendService.prototype.update = function (data) {
        var payload = data.serialize();
        return this.api.put(data.getUri() + '/' + data[data.getKey()], payload);
    };
    BackendService.prototype.createNew = function (data) {
        var payload = data.serialize();
        return this.api.post(data.getUri(), payload);
    };
    BackendService.prototype.destroy = function (data) {
        return this.api.delete(data.getUri() + '/' + data[data.getKey()]);
    };
    BackendService.prototype.get = function (model, options) {
        var _this = this;
        if (model === void 0) { model = null; }
        if (options === void 0) { options = { page: 1 }; }
        var requestOptions = {
            params: new HttpParams()
        };
        if (options.page != 1) {
            requestOptions.params = new HttpParams().set('page', String(options.page));
        }
        var observable;
        if (model === null) {
            observable = this.api.get(new this.model().getUri(), requestOptions);
        }
        else {
            observable = this.api.get(model.getUri(), requestOptions);
        }
        observable = observable.map(function (response) {
            var data = response.data;
            response.data = ModelFactory.makeFromArray(Models.get(_this.model.key), data);
            return response;
        });
        return observable;
    };
    BackendService.prototype.getRelated = function (related, key, model, options) {
        if (model === void 0) { model = null; }
        if (options === void 0) { options = {}; }
        if (model == null) {
            model = this.model;
        }
        var constructor = Models.get(model.key);
        model = ModelFactory.makeRelated(new constructor(), related, key);
        return this.get(model);
    };
    BackendService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    BackendService.ctorParameters = function () { return [
        { type: ApiService, },
    ]; };
    return BackendService;
}());
export { BackendService };
//# sourceMappingURL=backend.service.js.map