import { Relationship } from './relationship';
import { Models } from "./models";
var ModelFactory = (function () {
    function ModelFactory() {
    }
    ModelFactory.make = function (model, data) {
        return new model().deserialize(data);
    };
    ModelFactory.makeFromArray = function (model, array) {
        var models = [];
        for (var ii = 0; ii < array.length; ++ii) {
            models.push(new model().deserialize(array[ii]));
        }
        return models;
    };
    ModelFactory.makeRelated = function (model, related, key) {
        var relationshipConfig = model.getRelationship(key);
        var relationship = new Relationship(model, related, relationshipConfig.type);
        model[key] = relationship.create();
        model.setUri(model[key].getSelfUri() + '/' + model.getUri());
        return model;
    };
    ModelFactory.makeRelatedFromRelationship = function (relationship, input) {
        if (relationship.type == 'hasOne' || relationship.type == 'belongsTo') {
            return relationship.create().deserialize(input);
        }
        else if (relationship.type == 'hasMany') {
            var related = relationship.getRelated();
            var constructor = Models.get(related.key);
            return ModelFactory.makeFromArray(constructor, input);
        }
    };
    return ModelFactory;
}());
export { ModelFactory };
//# sourceMappingURL=model.factory.js.map